(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     22192,        630]
NotebookOptionsPosition[     18013,        530]
NotebookOutlinePosition[     18350,        545]
CellTagsIndexPosition[     18307,        542]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Recursive function definitions and patterns - Lecture 3", "Chapter",
 CellChangeTimes->{{3.746178094288385*^9, 3.74617810419829*^9}, {
  3.7462595931710052`*^9, 
  3.746259595066758*^9}},ExpressionUUID->"33f7606b-7dd3-4695-b487-\
c6757f0fc1d4"],

Cell["\<\
These notes are expanded upon what we talked about on Friday (14.9.)\
\>", "Text",
 CellChangeTimes->{{3.746260555114849*^9, 
  3.7462605751555557`*^9}},ExpressionUUID->"6f499112-4d02-4354-a910-\
8920a22a169d"],

Cell["\<\
Recursive definitions are sometimes extremely useful (sometimes not...). We \
go through a few examples of recursive definitions. I encourage you to go \
through these examples and think what every piece means.\
\>", "Text",
 CellChangeTimes->{{3.7462605048099813`*^9, 3.746260553306981*^9}, {
  3.746260584051737*^9, 
  3.746260617820903*^9}},ExpressionUUID->"1ef42df1-c92c-4a01-b994-\
268ec2a19614"],

Cell[CellGroupData[{

Cell["A trivial example", "Subsection",
 CellChangeTimes->{{3.746178160007625*^9, 
  3.746178162415769*^9}},ExpressionUUID->"eca33e92-45dd-4c81-b263-\
ff1dae0b4f8f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MyFunc", "[", "n_Integer", "]"}], "/;", 
    RowBox[{"n", ">", "0"}]}], " ", ":=", " ", 
   RowBox[{"a", "*", 
    RowBox[{"MyFunc", "[", 
     RowBox[{"n", "-", "1"}], "]"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"What", " ", "is", " ", 
    RowBox[{"\"\<_Integer\>\"", "?", " ", "What"}], " ", "is", " ", 
    RowBox[{"\"\</;n>0\>\"", "?"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MyFunc", "[", "0", "]"}], "=", "b"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"MyFunc", "[", "5", "]"}]}], "Input",
 CellChangeTimes->{{3.746178105893642*^9, 3.746178150135833*^9}, 
   3.746178222902698*^9, {3.746260620781149*^9, 
   3.746260641173888*^9}},ExpressionUUID->"1632fc6f-5efb-49ef-ad3d-\
cc594382ac27"]
}, Closed]],

Cell[CellGroupData[{

Cell["MyFactorial", "Subsection",
 CellChangeTimes->{{3.746178172095467*^9, 3.746178179215901*^9}, {
  3.746260482689373*^9, 
  3.746260482969295*^9}},ExpressionUUID->"3094ca34-d89f-4043-8b61-\
2db800ee23aa"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MyFactorial", "[", "0", "]"}], "=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MyFactorial", "[", "n_", "]"}], ":=", 
   RowBox[{"n", "*", 
    RowBox[{"MyFactorial", "[", 
     RowBox[{"n", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MyFactorial", "[", "5", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MyFactorial", "[", "5.5", "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{"The", " ", "definition", " ", "is", " ", "not", " ", 
    RowBox[{"complete", ".", " ", "How"}], " ", "would", " ", "you", " ", 
    "fix", " ", 
    RowBox[{"this", "?"}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.746178174365014*^9, 3.746178252810247*^9}, {
  3.746260650693568*^9, 
  3.746260653477632*^9}},ExpressionUUID->"5e9404e9-968a-4fa5-87d0-\
d22989230104"]
}, Closed]],

Cell[CellGroupData[{

Cell["Advanced use of patterns and recursion", "Subsection",
 CellChangeTimes->{{3.746178281625512*^9, 
  3.746178292969481*^9}},ExpressionUUID->"69485d90-2e39-4621-a820-\
4643b6358854"],

Cell["arg1_ (with a single underscore) refers to one element", "Text",
 CellChangeTimes->{{3.746178295925232*^9, 3.746178308330224*^9}, {
  3.74618700428458*^9, 
  3.746187005022456*^9}},ExpressionUUID->"0780f4af-d613-4afa-84c0-\
d2725d1cbeaf"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"func1", "[", "x_", "]"}], ":=", 
   RowBox[{"x", "^", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"func1", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"func1", "[", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{
   "Now", " ", "list", " ", "is", " ", "the", " ", "one", " ", "element"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"func1", "[", 
   RowBox[{"2", ",", "3"}], "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Two", " ", "arguments"}], ",", " ", 
    RowBox[{"no", " ", 
     RowBox[{"match", "!"}]}]}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.746178310954795*^9, 
  3.746178367107277*^9}},ExpressionUUID->"cb9f8540-8ba2-4d40-ad0d-\
1e3987060117"],

Cell["arg2__ (with two underscored) refers to one or more element", "Text",
 CellChangeTimes->{{3.746178377419158*^9, 
  3.746178390178947*^9}},ExpressionUUID->"3ffab8f0-77b7-47b3-ae1f-\
367fe02f8e72"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"func1", "[", "list__", "]"}], ":=", 
  RowBox[{"func1", "[", 
   RowBox[{"Times", "[", "list", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"func1", "[", "3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"func1", "[", 
  RowBox[{"2", ",", "3"}], "]"}]}], "Input",
 CellChangeTimes->{{3.746178394192706*^9, 
  3.746178435132328*^9}},ExpressionUUID->"f0e5c0d3-b11c-4070-b2e0-\
ed4d2c232c1d"],

Cell["They can be combined", "Text",
 CellChangeTimes->{{3.746178475876601*^9, 
  3.746178478076703*^9}},ExpressionUUID->"5e8b7d76-8264-4f75-9a92-\
004f117301b3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"func2", "[", 
    RowBox[{"a_", ",", "list__"}], "]"}], ":=", 
   RowBox[{"a", "*", 
    RowBox[{"func1", "[", "list", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"func2", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"func2", "[", "a", "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{
   "Does", " ", "not", " ", "work", " ", "output", " ", "anything", " ", 
    "meaningful"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.746178466611865*^9, 
  3.746178555549347*^9}},ExpressionUUID->"adeb5b35-e0a1-49ec-9eac-\
1633aa85c61b"],

Cell["arg3___ (three underscores) refers to zero or more elements.", "Text",
 CellChangeTimes->{{3.746178790547254*^9, 
  3.7461788071712437`*^9}},ExpressionUUID->"a93c0e3d-f035-4a51-8ab3-\
efcd4930385e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"func2", "[", 
   RowBox[{"a", ",", "list___"}], "]"}], ":=", 
  RowBox[{"a", "*", 
   RowBox[{"func1", "[", "list", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"func2", "[", "a", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"func1", "[", "]"}], "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"func2", "[", "a", "]"}]}], "Input",
 CellChangeTimes->{{3.746185758548746*^9, 3.746185776911214*^9}, {
  3.7461860164499903`*^9, 
  3.746186051674972*^9}},ExpressionUUID->"5f436ae1-8a27-4243-9f6f-\
a80e7eb279df"]
}, Open  ]],

Cell[CellGroupData[{

Cell["MySort (a slow example)", "Subsection",
 CellChangeTimes->{{3.7461786119915257`*^9, 3.7461786130235*^9}, {
  3.7462592407769203`*^9, 3.7462592468090878`*^9}, {3.74626015062558*^9, 
  3.7462601541212254`*^9}},ExpressionUUID->"2a71d91d-ac1b-4402-8583-\
9d56be70ba5f"],

Cell[BoxData[{
 RowBox[{"intlist", " ", "=", " ", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "20"}], ",", "20"}], "}"}], ",", 
    RowBox[{"{", "15", "}"}]}], "]"}]}], "\n", 
 RowBox[{"Sort", "[", "intlist", "]"}]}], "Input",
 CellChangeTimes->{{3.7461786191064653`*^9, 3.7461786291915913`*^9}, 
   3.746260686281035*^9},ExpressionUUID->"c378b3e0-b7d0-4579-9e0f-\
5c48e7785b11"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MySort", "[", 
     RowBox[{"before___", ",", "a_", ",", "b_", ",", "after___"}], "]"}], "/;", 
    RowBox[{"b", "<", "a"}]}], ":=", 
   RowBox[{"MySort", "[", 
    RowBox[{"before", ",", "b", ",", "a", ",", "after"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"MySort", "@@", "intlist"}], "\[IndentingNewLine]", 
 RowBox[{"List", " ", "@@", " ", 
  RowBox[{"MySort", "@@", "intlist", " "}]}]}], "Input",
 CellChangeTimes->{{3.746178649320218*^9, 3.746178689241296*^9}, {
  3.746178736419909*^9, 
  3.746178752674514*^9}},ExpressionUUID->"45995a2d-f538-40a3-b4ab-\
81edf719f658"],

Cell["\<\
Logic: Mathematica takes the list of integers given to the function and \
compares any two consecutive elements in the middle (or beginning or end).\
\>", "Text",
 CellChangeTimes->{{3.7461786146675777`*^9, 3.746178642712488*^9}, {
  3.746178714570757*^9, 3.7461787299378777`*^9}, {3.746178763706526*^9, 
  3.746178783139196*^9}},ExpressionUUID->"1868c4a2-aee0-40a6-a043-\
e3a5f0612ec4"],

Cell[CellGroupData[{

Cell["How fast is this? Very slow.", "Subsubsection",
 CellChangeTimes->{{3.746260161114027*^9, 
  3.74626017147409*^9}},ExpressionUUID->"ce232ab5-ed0f-47ae-b8a3-\
db5da18f395c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$IterationLimit", "=", "100000"}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{
   "We", " ", "need", " ", "this", " ", "for", " ", "larger", " ", "arrays", 
    " ", "just", " ", "to", " ", "finish", " ", "the", " ", "computation"}], 
   "*)"}]}]], "Input",
 CellChangeTimes->{{3.746260023399906*^9, 3.746260046639306*^9}, {
  3.746260214172097*^9, 
  3.746260227379632*^9}},ExpressionUUID->"c265d380-a648-459c-968a-\
ad584645efa6"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Timing", "[", 
   RowBox[{"List", "@@", 
    RowBox[{"MySort", "@@", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
       RowBox[{"{", "400", "}"}]}], "]"}]}]}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Timing", "[", 
   RowBox[{"List", "@@", 
    RowBox[{"MySort", "@@", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
       RowBox[{"{", "200", "}"}]}], "]"}]}]}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.746259609238057*^9, 3.746259610467909*^9}, {
  3.74625988927542*^9, 3.7462599139315243`*^9}, {3.746259960622148*^9, 
  3.746260067535802*^9}, {3.746260211819501*^9, 
  3.74626024249977*^9}},ExpressionUUID->"2fdf27e3-2a6b-44be-a725-\
dde7ccee329a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Timing", "[", 
    RowBox[{"Sort", "[", 
     RowBox[{"RandomReal", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
       RowBox[{"{", "4000", "}"}]}], "]"}], "]"}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "Compare", " ", "with", " ", "10", " ", "times", " ", "larger", " ", 
     "array", " ", "with", " ", "built"}], "-", 
    RowBox[{"in", " ", "sort"}]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.746260245038625*^9, 
  3.746260261972768*^9}},ExpressionUUID->"ab6cd0c9-4e0c-43fb-9f29-\
a83738bf99e1"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Even more complicated patterns", "Subsection",
 CellChangeTimes->{{3.74625794165979*^9, 
  3.746257945420542*^9}},ExpressionUUID->"e0b9d6f6-0ad4-42c4-99a7-\
f37cf35fe64b"],

Cell["We could define", "Text",
 CellChangeTimes->{{3.746257964603739*^9, 
  3.746257966222007*^9}},ExpressionUUID->"0a061604-5bda-486f-b7b0-\
f594cb5e27dd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fex1", "[", 
    RowBox[{"a_", "*", "b_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"fex1", "[", "a", "]"}], "+", 
    RowBox[{"fex1", "[", "b", "]"}]}]}], ";", " ", 
  RowBox[{"(*", 
   RowBox[{"Logarithm", ",", " ", 
    RowBox[{
     RowBox[{"anyone", "?", " ", "We"}], " ", "now", " ", "give", " ", 
     "pattern", " ", "\"\<term1 * term2 inside function fex1\>\""}]}], "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{"fex1", "[", 
   RowBox[{"x", "*", "y", "*", "z", "*", "\[ARing]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fex1", "[", 
   RowBox[{"2", "*", "3"}], "]"}], " ", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"doesn", "'"}], "t", " ", "do", " ", "anything", " ", 
    "interesting", " ", "as", " ", "2", "*", "3", " ", "is", " ", "evaluated",
     " ", "before", " ", "function", " ", "evaluation"}], "*)"}]}]}], "Input",\

 CellChangeTimes->{{3.74625796974714*^9, 3.746258068027965*^9}, {
  3.7462582805569677`*^9, 3.746258285284515*^9}, {3.746258895311558*^9, 
  3.746258902455711*^9}, {3.746260716455628*^9, 3.74626072203148*^9}, {
  3.7462607552237167`*^9, 
  3.746260782705016*^9}},ExpressionUUID->"18c63b4e-74dc-48b5-afc5-\
7274770b3c2a"],

Cell["More complicated examples", "Text",
 CellChangeTimes->{{3.74625812467449*^9, 
  3.7462581277625017`*^9}},ExpressionUUID->"12ee5133-2071-47e6-9d94-\
add353a0d637"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fex2", "[", 
    RowBox[{"a_", "*", 
     RowBox[{"x", "^", "b_"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "+", "1"}], ")"}], " ", 
    RowBox[{"fex2", "[", "a", "]"}]}]}], " ", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"This", " ", "may", " ", "be", " ", "an", " ", "ill"}], "-", 
     RowBox[{
     "defined", " ", "definition", " ", "in", " ", "a", " ", "mathematical", 
      " ", "sense"}]}], ",", " ", 
    RowBox[{"we", " ", 
     RowBox[{"don", "'"}], "t", " ", "care"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"fex2", "[", 
  RowBox[{"\[Pi]", " ", "*", " ", 
   RowBox[{"x", "^", "4"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"fex2", "[", 
  RowBox[{"\[Pi]", " ", "x"}], "]"}]}], "Input",
 CellChangeTimes->{{3.7462580925757504`*^9, 3.7462581500533323`*^9}, {
   3.746258287332703*^9, 3.746258290173037*^9}, {3.746258345175943*^9, 
   3.746258345319407*^9}, 3.746258385442499*^9, {3.746258666238379*^9, 
   3.7462586663278427`*^9}, {3.7462589065751743`*^9, 
   3.7462589238707848`*^9}, {3.746259093045336*^9, 3.746259099712421*^9}, {
   3.7462591304460897`*^9, 
   3.746259155374734*^9}},ExpressionUUID->"d4ccf57a-18d0-48d2-9002-\
c600af2eaae9"],

Cell["However:", "Text",
 CellChangeTimes->{{3.746258308797181*^9, 
  3.74625830971716*^9}},ExpressionUUID->"0aca0d46-47ef-4714-8d8e-\
1482d4acf17c"],

Cell[BoxData[
 RowBox[{"fex2", "[", 
  RowBox[{"\[Pi]", "*", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.746258311901866*^9, 3.746258319509836*^9}, {
  3.746258354119522*^9, 3.746258354336129*^9}, {3.746258415891252*^9, 
  3.746258418934022*^9}},ExpressionUUID->"3e5f108c-0ff8-42af-bff9-\
9d1b27823cc8"],

Cell["x does not have an explicit exponent", "Text",
 CellChangeTimes->{{3.746258431283112*^9, 3.74625845268388*^9}, {
  3.7462591146611547`*^9, 
  3.746259116517284*^9}},ExpressionUUID->"54339d7a-6c5c-4172-8253-\
656ae039b82e"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fex2", "[", 
   RowBox[{"\[Pi]", "*", "x"}], "]"}], "//", "FullForm"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"fex2", "[", 
    RowBox[{"a_", "*", 
     RowBox[{"x", "^", "b_"}]}], "]"}], "//", "HoldForm"}], "//", 
  "FullForm"}]}], "Input",
 CellChangeTimes->{{3.746258458605126*^9, 
  3.746258500710524*^9}},ExpressionUUID->"9cd12ec3-f08c-4e3a-8142-\
ede52d094f04"],

Cell["\<\
We need an option with Optional. If x does not have an exponent, assume it to \
be one.\
\>", "Text",
 CellChangeTimes->{{3.746259184175764*^9, 3.746259199447694*^9}, {
  3.7462592729621887`*^9, 
  3.7462592773456507`*^9}},ExpressionUUID->"066a42f0-8967-414d-8fc4-\
31311885916d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fex3", "[", 
   RowBox[{"a_", "*", 
    RowBox[{"x", "^", 
     RowBox[{"(", 
      RowBox[{"b_:", "1"}], ")"}]}]}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"b", "+", "1"}], ")"}], 
   RowBox[{"fex3", "[", "a", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fex3", "[", 
    RowBox[{"a_", "*", 
     RowBox[{"x", "^", 
      RowBox[{"(", 
       RowBox[{"b_:", "1"}], ")"}]}]}], "]"}], "//", "HoldForm"}], "//", 
  "FullForm"}], "\[IndentingNewLine]", 
 RowBox[{"fex3", "[", 
  RowBox[{"a", "*", 
   RowBox[{"x", "^", "n"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"fex3", "[", 
  RowBox[{"a", "*", "x"}], "]"}]}], "Input",
 CellChangeTimes->{{3.746258769305752*^9, 3.746258773673613*^9}, {
   3.746258847149652*^9, 3.746258851516852*^9}, 3.746259174384081*^9, {
   3.746259314395535*^9, 3.746259351020775*^9}, {3.746259405990715*^9, 
   3.746259407590405*^9}, {3.746259508809451*^9, 
   3.7462595572861643`*^9}},ExpressionUUID->"0c70a050-f02d-4be5-a59b-\
df563bfd1a1c"],

Cell["There is another way.", "Text",
 CellChangeTimes->{{3.746260347494038*^9, 
  3.746260349894038*^9}},ExpressionUUID->"4c7276f1-45e8-41be-8b8a-\
515f3466fe22"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ClearAll", "[", "fex3", "]"}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fex3", "[", 
    RowBox[{"a_", "*", 
     RowBox[{"x", "^", "b_."}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"b", "+", "1"}], ")"}], 
    RowBox[{"fex3", "[", "a", "]"}]}]}], " ", 
  RowBox[{"(*", 
   RowBox[{"alternatively", ",", " ", 
    RowBox[{"use", " ", "_.", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"notice", " ", "dot"}], ")"}], ".", " ", 
      "\"\<x to the power of b OR just x\>\""}]}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"fex3", "[", 
  RowBox[{"a", "*", 
   RowBox[{"x", "^", "n"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"fex3", "[", 
  RowBox[{"a", "*", "x"}], "]"}]}], "Input",
 CellChangeTimes->{{3.746258769305752*^9, 3.746258773673613*^9}, {
   3.746258847149652*^9, 3.746258851516852*^9}, 3.746259174384081*^9, {
   3.746259314395535*^9, 3.746259351020775*^9}, {3.746259405990715*^9, 
   3.746259407590405*^9}, {3.746259508809451*^9, 3.746259580107749*^9}, {
   3.746260799425495*^9, 
   3.746260813289983*^9}},ExpressionUUID->"03db4b68-30bb-4d6c-b773-\
049d4ec8fee7"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1147, 713},
WindowMargins->{{Automatic, 341}, {48, Automatic}},
FrontEndVersion->"11.1 for Linux x86 (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 250, 4, 66, "Chapter", "ExpressionUUID" -> \
"33f7606b-7dd3-4695-b487-c6757f0fc1d4"],
Cell[833, 28, 220, 5, 31, "Text", "ExpressionUUID" -> \
"6f499112-4d02-4354-a910-8920a22a169d"],
Cell[1056, 35, 411, 8, 51, "Text", "ExpressionUUID" -> \
"1ef42df1-c92c-4a01-b994-268ec2a19614"],
Cell[CellGroupData[{
Cell[1492, 47, 165, 3, 45, "Subsection", "ExpressionUUID" -> \
"eca33e92-45dd-4c81-b263-ff1dae0b4f8f"],
Cell[1660, 52, 784, 20, 79, "Input", "ExpressionUUID" -> \
"1632fc6f-5efb-49ef-ad3d-cc594382ac27"]
}, Closed]],
Cell[CellGroupData[{
Cell[2481, 77, 208, 4, 37, "Subsection", "ExpressionUUID" -> \
"3094ca34-d89f-4043-8b61-2db800ee23aa"],
Cell[2692, 83, 848, 22, 101, "Input", "ExpressionUUID" -> \
"5e9404e9-968a-4fa5-87d0-d22989230104"]
}, Closed]],
Cell[CellGroupData[{
Cell[3577, 110, 186, 3, 37, "Subsection", "ExpressionUUID" -> \
"69485d90-2e39-4621-a820-4643b6358854"],
Cell[3766, 115, 244, 4, 31, "Text", "ExpressionUUID" -> \
"0780f4af-d613-4afa-84c0-d2725d1cbeaf"],
Cell[4013, 121, 803, 24, 124, "Input", "ExpressionUUID" -> \
"cb9f8540-8ba2-4d40-ad0d-1e3987060117"],
Cell[4819, 147, 201, 3, 31, "Text", "ExpressionUUID" -> \
"3ffab8f0-77b7-47b3-ae1f-367fe02f8e72"],
Cell[5023, 152, 424, 10, 79, "Input", "ExpressionUUID" -> \
"f0e5c0d3-b11c-4070-b2e0-ed4d2c232c1d"],
Cell[5450, 164, 162, 3, 31, "Text", "ExpressionUUID" -> \
"5e8b7d76-8264-4f75-9a92-004f117301b3"],
Cell[5615, 169, 622, 17, 79, "Input", "ExpressionUUID" -> \
"adeb5b35-e0a1-49ec-9eac-1633aa85c61b"],
Cell[6240, 188, 204, 3, 31, "Text", "ExpressionUUID" -> \
"a93c0e3d-f035-4a51-8ab3-efcd4930385e"],
Cell[6447, 193, 564, 14, 101, "Input", "ExpressionUUID" -> \
"5f436ae1-8a27-4243-9f6f-a80e7eb279df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7048, 212, 271, 4, 45, "Subsection", "ExpressionUUID" -> \
"2a71d91d-ac1b-4402-8583-9d56be70ba5f"],
Cell[7322, 218, 432, 11, 56, "Input", "ExpressionUUID" -> \
"c378b3e0-b7d0-4579-9e0f-5c48e7785b11"],
Cell[7757, 231, 650, 16, 78, "Input", "ExpressionUUID" -> \
"45995a2d-f538-40a3-b4ab-81edf719f658"],
Cell[8410, 249, 397, 7, 31, "Text", "ExpressionUUID" -> \
"1868c4a2-aee0-40a6-a043-e3a5f0612ec4"],
Cell[CellGroupData[{
Cell[8832, 260, 178, 3, 35, "Subsubsection", "ExpressionUUID" -> \
"ce232ab5-ed0f-47ae-b8a3-db5da18f395c"],
Cell[9013, 265, 463, 11, 34, "Input", "ExpressionUUID" -> \
"c265d380-a648-459c-968a-ad584645efa6"],
Cell[9479, 278, 973, 27, 57, "Input", "ExpressionUUID" -> \
"2fdf27e3-2a6b-44be-a725-dde7ccee329a"],
Cell[10455, 307, 680, 20, 56, "Input", "ExpressionUUID" -> \
"ab6cd0c9-4e0c-43fb-9f29-a83738bf99e1"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[11184, 333, 177, 3, 37, "Subsection", "ExpressionUUID" -> \
"e0b9d6f6-0ad4-42c4-99a7-f37cf35fe64b"],
Cell[11364, 338, 157, 3, 30, "Text", "ExpressionUUID" -> \
"0a061604-5bda-486f-b7b0-f594cb5e27dd"],
Cell[11524, 343, 1223, 31, 78, "Input", "ExpressionUUID" -> \
"18c63b4e-74dc-48b5-afc5-7274770b3c2a"],
Cell[12750, 376, 168, 3, 31, "Text", "ExpressionUUID" -> \
"12ee5133-2071-47e6-9d94-add353a0d637"],
Cell[12921, 381, 1254, 32, 78, "Input", "ExpressionUUID" -> \
"d4ccf57a-18d0-48d2-9002-c600af2eaae9"],
Cell[14178, 415, 149, 3, 30, "Text", "ExpressionUUID" -> \
"0aca0d46-47ef-4714-8d8e-1482d4acf17c"],
Cell[14330, 420, 305, 6, 32, "Input", "ExpressionUUID" -> \
"3e5f108c-0ff8-42af-bff9-9d1b27823cc8"],
Cell[14638, 428, 228, 4, 31, "Text", "ExpressionUUID" -> \
"54339d7a-6c5c-4172-8253-656ae039b82e"],
Cell[14869, 434, 404, 12, 56, "Input", "ExpressionUUID" -> \
"9cd12ec3-f08c-4e3a-8142-ede52d094f04"],
Cell[15276, 448, 290, 7, 31, "Text", "ExpressionUUID" -> \
"066a42f0-8967-414d-8fc4-31311885916d"],
Cell[15569, 457, 1053, 29, 101, "Input", "ExpressionUUID" -> \
"0c70a050-f02d-4be5-a59b-df563bfd1a1c"],
Cell[16625, 488, 163, 3, 31, "Text", "ExpressionUUID" -> \
"4c7276f1-45e8-41be-8b8a-515f3466fe22"],
Cell[16791, 493, 1194, 33, 101, "Input", "ExpressionUUID" -> \
"03db4b68-30bb-4d6c-b773-049d4ec8fee7"]
}, Open  ]]
}, Open  ]]
}
]
*)

